/************************************************************************/
/* sdlsysc.h: SDL library wrapper for image display in SystemC models	*/
/*									*/
/* 03/26/15 GL	original version (based on sdlspecc.h)			*/
/************************************************************************/ 

#ifndef _SDL_SYSC_H
#define _SDL_SYSC_H

#ifndef __SYSC__
extern "C" {
#endif

void _SDL_SysC_InitDisplay(unsigned int w, unsigned int h, const char *title);

void _SDL_SysC_DrawPixel(unsigned char r, unsigned char g, unsigned char b, unsigned int x, unsigned int y);

void _SDL_SysC_UpdateRect(unsigned int x, unsigned int y, unsigned int w, unsigned int h);

void _SDL_SysC_ClearDisplay(void);

void _SDL_SysC_FillDisplay(unsigned char r, unsigned char g, unsigned char b);

int  _SDL_SysC_DisplayClosed(void);

#ifndef __SYSC__
} /* extern "C" */
#endif

#endif /* _SDL_SYSC_H */

/* EOF */
