#include "systemc.h"

class Misc: public sc_module {
public:
  int x, y, z;
  sc_event e;
  bool test;

  SC_HAS_PROCESS(Misc);

  void misc_segment_fault_for()
  {
    int aa = 0;
    for(int ii = 0; ii < 10; ii++)
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
        }
      }
    }
  }

  void misc_segment_fault_while()
  {
    int aa = 0;
    while(true)
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
        }
      }
    }
  }

  void misc_segment_fault_do_while()
  {
    int aa = 0;
    do
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
        }
      }
    } while(true);
  }



  void misc_infinity_loop_for()
  {
    int aa = 0;
    for(int ii = 0; ii < 10; ii++)
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
          break;
        }
      }
    }
  }

  void misc_infinity_loop_while()
  {
    int aa = 0;
    while(true) {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
          break;
        }
      }
    }
  }


  void misc_infinity_loop_do_while()
  {
    int aa = 0;
    do
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
          break;
        }
      }
    } while (true);
  }

  void misc_infinity()
  {
    for(int i =0; i<12; i++)
    {
      if(true){

        wait();
      }
    }
  }

  void misc_null_expresssion()
  {
    int aa = 0;
    for(int ii = 0; ii < 10; ii++)
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          int bb;
          wait();
          int cc;
        }
      }
    }
    int dd;
  }

  void misc_segment_fault_for_dd()
  {
    int aa = 0;
    for(int ii = 0; ii < 10; ii++)
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
        }
      }
    }
    int dd;
    wait();
    int ee;
  }

  void misc_segment_fault_while_dd()
  {
    int aa = 0;
    while(aa < 10)
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
        }
      }
    }
    int dd;
    wait();
    int ee;
  }

  void misc_segment_fault_do_while_dd()
  {
    int aa = 0;

    do
    {
      if(aa == 1)
      {
        if(aa == 2)
        {
          wait();
        }
      }
    } while(aa < 10);

    int dd;
    wait();
    int ee;
  }

  void misc_break_over_multiple_basic_blocks_1()
  {
    bool bool_var = false;
    int aa = 1;

    switch(aa) {

      case 3:
      {
        if(aa == 2) {
          int bb;
          wait();
          break;
        } else {
          int cc;
          wait();
          int dd;
        }
        int ee;
      }
    }
    int ff;
    wait();
    int gg;
  }

  void misc_break_over_multiple_basic_blocks_2()
  {
    bool bool_var = false;
    int aa = 1;

    switch(aa) {

      case 3:
      {
        if(aa == 2) {
          int bb;
          wait();
          break;
        } else {
          int cc;
          wait();
          int dd;
        }
        int ee;
      }
      case 4:
      {
        int ff;
        wait();
        int gg;
      }
    }
    int hh;
    wait();
    int ii;
  }

  void misc_break_over_multiple_basic_blocks_3()
  {
    bool bool_var = false;
    int aa = 1;

    while(aa>1) {

      if(aa == 2) {
        int bb;
        wait();
        break;
      } else {
        int cc;
        wait();
        int dd;
      }
      int ee;
    }
    int ff;
    wait();
    int gg;
  }

  void misc_segment_fault_do_while_1()
  {
    int aa = 0;
    do
    {
      int bb;
      if(aa == 1)
      {
        int cc;
        if(aa == 2)
        {
          int dd;
          wait();
          int ee;
        }
        int ff;
      }
      int gg;
    } while(true);
    int hh;
    wait();
    int ii;
  }

  void misc_infinity_loop_for_1()
  {
    int aa = 0;
    for(int ii = 0; ii < 10; ii++)
    {
      int bb;
      if(aa == 1)
      {
        int cc;
        if(aa == 2)
        {
          int dd;
          wait();
          int ee;
          break;
          int ff;
        }
        int gg;
      }
      int hh;
    }
    int ii;
    wait();
    int jj;
  }

  void misc_infinity_loop_while_1()
  {
    int aa = 0;
    while(true) {
      int bb;
      if(aa == 1)
      {
        int cc;
        if(aa == 2)
        {
          int dd;
          wait();
          int ee;
          break;
          int ff;
        }
        int gg;
      }
      int hh;
    }
    int ii;
    wait();
    int jj;
  }

  void misc_infinity_loop_do_while_1()
  {
    int aa = 0;
    do
    {
      int bb;
      if(aa == 1)
      {
        int cc;
        if(aa == 2)
        {
          int dd;
          wait();
          int ee;
          break;
          int ff;
        }
        int gg;
      }
      int hh;
    } while (true);
    int ii;
    wait();
    int jj;
  }

  void misc_break_delayed()
  {
    int kk;
    wait();
    while(true) {

      int aa;
      wait();
      int bb;
      bool bool_var;
      if(bool_var) {
        break;
      }
      int cc;
      wait();
      int dd;
      wait();
      int ee;
      wait();
      int ff;
    }
    int gg;
    wait();
    int hh;
  }

  void misc_continue_delayed()
  {
    int kk;
    wait();
    while(true) {

      int aa;
      wait();
      int bb;
      bool bool_var;
      if(bool_var) {
        continue;
      }
      int cc;
      wait();
      int dd;
      wait();
      int ee;
      wait();
      int ff;
    }
    int gg;
    wait();
    int hh;
  }

  void misc_switch_double_continue()
  {
    wait();
    int aa = 1;
    for(int ii = 0; ii < 10; ii++)
    {
      int bb;
      switch(aa)
      {
        case 1:
        {
          int cc;
          if(aa == 1)
          {
            int dd;
            wait();
            continue;
          }
          else
          {
            int ee;
            wait();
            continue;
          }
          int ff;
          break;
        }
        case 2:
        {
          int gg;
          break;
        }
      }
    }
    int yy;
    wait();
    int zz;
  }

  void misc_switch_double_continue_1()
  {
    wait();
    int aa = 1;
    for(int ii = 0; ii < 10; ii++)
    {
      int bb;
      if(aa == 1)
      {
        int cc;
        wait();
        int dd;
        continue;
        int ee;
      }
      else
      {
        int ff;
        wait();
        int gg;
        continue;
        int hh;
      }
      int jj;
      break;
    }
    int yy;
    wait();
    int zz;
  }

  void misc_missing_operator_1()
  {
    //Nth Root
    //http://rosettacode.org/wiki/Nth_root
    double ret = 1;
    double x = -3.14159;
    double e = 15.0;
    for(ret = 1; e; x*=x, e=1)
      if((e==1))
        ret*=x;
    double a = ret;
    int n = 15;
    double d;
    x=1;
    if(!a)
      return;
    if (n < 1 || (a < 0 && !(n&1)))
      return;
    do {
      d = ((a/x*(n-1))-x)/n;
      x+=d;
    } while ((-d) >= (-x) * (d*10));
  }

  void misc_missing_operator_2()
  {
    //Adapted from http://rosettacode.org/wiki/100_doors#C.2B.2B
    bool is_open[100] = { false };

    // do the 100 passes
    for (int pass = 0; pass < 100; ++pass)
      for (int door = pass; door < 100; door += pass+1)
        is_open[door] = !is_open[door];
  }

  void misc_missing_operator_3()
  {
    //adapted from http://rosettacode.org/wiki/Hofstadter_Q_sequence#C.2B.2B
     int hofstadters[100000] ;
     hofstadters[ 0 ] = 1 ;
     hofstadters[ 1 ] = 1 ;
     for ( int i = 3 ; i < 100000 ; i++ )
        hofstadters[ i - 1 ] = hofstadters[ i - 1 - hofstadters[ i - 1 - 1 ]] +
     hofstadters[ i - 1 - hofstadters[ i - 2 - 1 ]] ;
     for ( int i = 0 ; i < 10 ; i++ )
        hofstadters[i];
     int less_than_preceding = 0 ;
     for ( int i = 0 ; i < 99999 ; i++ ) {
        if ( hofstadters[ i + 1 ] < hofstadters[ i ] )
     less_than_preceding++ ;
     }
  }

  void misc_missing_operator_4()
  {
    //adapted from N-Queens Problem:
    //http://rosettacode.org/wiki/N-queens_problem
    int count = 0;
    int n, col=2;
    if ((n <= 1) || (n = 3 <= 0)) n = 8;
    int hist[n];
    if (col == n) {
      ++count;
      for (int i = 0; i < n; i++, putchar('\n'))
        for (int j = 0; j < n; j++)
          putchar(j == hist[i] ? 'Q' : ((i + j) & 1) ? ' ' : '.');
      return;
    }
    for(int i = 0, j = 0; i < n; i++) {
      for(j = 0;
          j < col && !(hist[j] == i || abs(hist[j] - i) == col - j);
          j++);
        if(j < col) continue;

      hist[col] = i;
    }
  }

  Misc(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(misc_segment_fault_for);
    SC_THREAD(misc_segment_fault_while);
    SC_THREAD(misc_segment_fault_do_while);
    SC_THREAD(misc_infinity_loop_for);
    SC_THREAD(misc_infinity_loop_do_while);
    SC_THREAD(misc_infinity_loop_while);
    SC_THREAD(misc_infinity);
    SC_THREAD(misc_null_expresssion);
    SC_THREAD(misc_segment_fault_for_dd);
    SC_THREAD(misc_segment_fault_while_dd);
    SC_THREAD(misc_segment_fault_do_while_dd);
    SC_THREAD(misc_break_over_multiple_basic_blocks_1);
    SC_THREAD(misc_break_over_multiple_basic_blocks_2);
    SC_THREAD(misc_break_over_multiple_basic_blocks_3);
    SC_THREAD(misc_infinity_loop_for_1);
    SC_THREAD(misc_infinity_loop_do_while_1);
    SC_THREAD(misc_infinity_loop_while_1);
    SC_THREAD(misc_break_delayed);
    SC_THREAD(misc_continue_delayed);
    SC_THREAD(misc_switch_double_continue);
    SC_THREAD(misc_switch_double_continue_1);
    SC_THREAD(misc_missing_operator_1);
    SC_THREAD(misc_missing_operator_2); // I think this is no longer...
    SC_THREAD(misc_missing_operator_3);
    SC_THREAD(misc_missing_operator_4);
  }
};



#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  Misc mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
