#include "primitive_channel_instance.h"

risc::PrimitiveChannelInstance::PrimitiveChannelInstance(
    SgVariableDefinition *ast_node,
    PrimitiveChannel *definition):
  Instance(ast_node, PrimitiveChannelInstanceType),
  definition_(definition)
{
  definition_->instances_.push_back(this);
}

std::string
risc::PrimitiveChannelInstance::get_ast_type_name()
{
  return get_ast_type()->unparseToString().substr(17);
}

risc::PrimitiveChannel* risc::PrimitiveChannelInstance::get_definition()
{
  return definition_;
}

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
