// bug20180723b.cc
// (was const_sig.cpp reported by DM 07/23/18)

#include "systemc.h"

SC_MODULE(TOP) {
sc_out<bool> out;
sc_signal<bool> open_sig;

	SC_CTOR(TOP) {
		out.bind(open_sig);	// this should be acceptable
		out.write(true);	// this might not be legal!?
		SC_THREAD(behav);
	}

//	void before_end_of_elaboration(void) {	// better, but RISC still fails
//		out.bind(open_sig);
//		out.write(true);
//	}

	void behav() {
		if(open_sig.read()) {
			cout << "constant signal read\n";
		}
	}
};

int sc_main(int argc, char* argv[] ) {
TOP t("t");
sc_start();
return 0;
}
